QGIS Server: WFS issue using the EXP_FILTER parameter
2019-01-06 11:33 AM - Geo Dev

Status: Closed

Priority: High

Assignee: Alessandro Pasotti

Category: QGIS Server

Affected QGIS version:3.5(master) Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 28746

Description

The EXP_FILTER parameter is evaluated only querying the layer fields with the basic operators (">", "<", "=", "LIKE", etc.)

The filter doesn't work using QGIS expressions.
Examples of WFS requests where the expressions are evaluated:
- http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldA&quot;&gt;10

- http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldA&gquot;&gt;10 AND "fieldB"<=100
- http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldC" LIKE 'demo’

Examples of WFS requests where the expressions are NOT evaluated:

- http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=area($geometry)&gt;100
- http://...?service=WF S&#38;request=GetFeature&#38;...&#38;EXP_FILTER=contains($geometry, geom_from_wkt('..."))
- http://...?service=WF S&#38;request=GetFeature&#38;...&#38;EXP_FILTER=intersects($geometry, geom_from_gmi('..."))

http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldA&quot;=concat(&#39;...&#39;,&#39;...&#39;)

Tested with QGIS 3.4.3 and QGIS 3.5(master).
The issue occurs both with WFS 1.0.0 and WFS 1.1.0.

It's a regression since the same requests on the same projects/layers published with QGIS Server 2.18 work as expected.

Associated revisions

Revision 9b7e1912 - 2019-01-21 12:37 PM - Alessandro Pasotti

Add tests for WFS GetFeature EXP_FILTER

Fixes #20927 - QGIS Server: WFS issue using the EXP_FILTER parameter

History

#1 - 2019-01-21 11:24 AM - Alessandro Pasotti
- Assignee set to Alessandro Pasotti

#2 - 2019-01-21 12:39 PM - Alessandro Pasotti

- Pull Request or Patch supplied changed from No to Yes

- Status changed from Open to In Progress
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldA&quot;&gt;10
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldA&quot;&gt;10
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldC
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=area($geometry)&gt;100
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=contains($geometry
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=intersects($geometry
http://...?service=WFS&#38;request=GetFeature&#38;...&#38;EXP_FILTER=&quot;fieldA&quot;=concat(&#39;...&#39;,&#39;...&#39;)

PR https://github.com/qgis/QGIS/pull/8924

#3 - 2019-01-22 08:04 AM - Alessandro Pasotti
- % Done changed from 0 to 100
- Status changed from In Progress to Closed

Applied in changeset commit:qgis|9b7e1912d427e3f1be55da2e675340da5230114f.
